#ifndef recc_implementation_DIR_asm_functions_DOT_h
#define recc_implementation_DIR_asm_functions_DOT_h
/*
    Copyright 2016 Robert Elder Software Inc.
    
    Licensed under the Apache License, Version 2.0 (the "License"); you may not 
    use this file except in compliance with the License.  You may obtain a copy 
    of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
    License for the specific language governing permissions and limitations 
    under the License.
*/

#ifndef recc_implementation_DIR_asm_DOT_h
#include "asm.h"
#endif
unsigned int undo_basic_asm_operation(struct asm_state *, enum asm_operation_type);
void create_asm_state(struct asm_state *, struct memory_pool_collection *);
void destroy_asm_state(struct asm_state *);
void print_all_aggregate_type_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_aggregate_type_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct aggregate_type_specifier_id);
struct aggregate_type_specifier_details get_aggregate_type_specifier_details_by_id(struct asm_state *, struct aggregate_type_specifier_id);
struct simple_type_specifier_id get_simple_type_specifier_id_simple_type_specifier_from_aggregate_type_specifier(struct aggregate_type_specifier_details);
struct scoped_tag_specifier_id get_scoped_tag_specifier_id_tag_specifier_from_aggregate_type_specifier(struct aggregate_type_specifier_details);
struct scoped_typename_specifier_id get_scoped_typename_specifier_id_typename_specifier_from_aggregate_type_specifier(struct aggregate_type_specifier_details);
void print_all_simple_type_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_simple_type_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct simple_type_specifier_id);
struct simple_type_specifier_details get_simple_type_specifier_details_by_id(struct asm_state *, struct simple_type_specifier_id);
void print_all_simple_type_qualifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_simple_type_qualifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct simple_type_qualifier_id);
struct simple_type_qualifier_details get_simple_type_qualifier_details_by_id(struct asm_state *, struct simple_type_qualifier_id);
void print_all_simple_storage_class_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_simple_storage_class_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct simple_storage_class_specifier_id);
struct simple_storage_class_specifier_details get_simple_storage_class_specifier_details_by_id(struct asm_state *, struct simple_storage_class_specifier_id);
void print_all_specifier_or_qualifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_specifier_or_qualifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct specifier_or_qualifier_id);
struct specifier_or_qualifier_details get_specifier_or_qualifier_details_by_id(struct asm_state *, struct specifier_or_qualifier_id);
struct simple_storage_class_specifier_id get_simple_storage_class_specifier_id_simple_storage_class_specifier_from_specifier_or_qualifier(struct specifier_or_qualifier_details);
struct simple_type_qualifier_id get_simple_type_qualifier_id_simple_type_qualifier_from_specifier_or_qualifier(struct specifier_or_qualifier_details);
struct aggregate_type_specifier_id get_aggregate_type_specifier_id_aggregate_type_specifier_from_specifier_or_qualifier(struct specifier_or_qualifier_details);
void print_all_specifier_or_qualifier_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_specifier_or_qualifier_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct specifier_or_qualifier_list_item_id, unsigned int);
struct specifier_or_qualifier_list_item_details get_specifier_or_qualifier_list_item_details_by_id(struct asm_state *, struct specifier_or_qualifier_list_item_id);
struct specifier_or_qualifier_list_item_id get_specifier_or_qualifier_list_item_prev_id_specifier_or_qualifier_from_specifier_or_qualifier_list_item(struct specifier_or_qualifier_list_item_details);
struct specifier_or_qualifier_id get_specifier_or_qualifier_item_id_specifier_or_qualifier_from_specifier_or_qualifier_list_item(struct specifier_or_qualifier_list_item_details);
void print_all_parameter_lists(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_parameter_list(struct asm_state *, unsigned int, struct unsigned_char_list *, struct parameter_list_id);
struct parameter_list_details get_parameter_list_details_by_id(struct asm_state *, struct parameter_list_id);
struct general_type_list_item_id get_general_type_list_item_general_type_list_item_id_variadic_from_parameter_list(struct parameter_list_details);
struct general_type_list_item_id get_general_type_list_item_general_type_list_item_id_non_variadic_from_parameter_list(struct parameter_list_details);
void print_all_declarator_parts(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_declarator_part(struct asm_state *, unsigned int, struct unsigned_char_list *, struct declarator_part_id);
struct declarator_part_details get_declarator_part_details_by_id(struct asm_state *, struct declarator_part_id);
struct function_part_id get_function_part_id_function_from_declarator_part(struct declarator_part_details);
struct pointer_part_id get_pointer_part_id_pointer_from_declarator_part(struct declarator_part_details);
struct array_part_id get_array_part_id_array_from_declarator_part(struct declarator_part_details);
void print_all_any_statement_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_any_statement_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct any_statement_list_item_id, unsigned int);
struct any_statement_list_item_details get_any_statement_list_item_details_by_id(struct asm_state *, struct any_statement_list_item_id);
struct any_statement_list_item_id get_any_statement_list_item_prev_id_any_statement_from_any_statement_list_item(struct any_statement_list_item_details);
struct any_statement_id get_any_statement_item_id_any_statement_from_any_statement_list_item(struct any_statement_list_item_details);
void print_all_anonymous_tag_definitions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_anonymous_tag_definition(struct asm_state *, unsigned int, struct unsigned_char_list *, struct anonymous_tag_definition_id);
struct anonymous_tag_definition_details get_anonymous_tag_definition_details_by_id(struct asm_state *, struct anonymous_tag_definition_id);
struct tag_definition_id get_tag_definition_tag_definition_id_anonymous_from_anonymous_tag_definition(struct anonymous_tag_definition_details);
struct scope_guid_id get_scope_guid_scope_guid_id_anonymous_from_anonymous_tag_definition(struct anonymous_tag_definition_details);
struct anonymous_entry_id get_anonymous_entry_anonymous_entry_id_anonymous_from_anonymous_tag_definition(struct anonymous_tag_definition_details);
void print_all_named_tag_predeclarations(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_named_tag_predeclaration(struct asm_state *, unsigned int, struct unsigned_char_list *, struct named_tag_predeclaration_id);
struct named_tag_predeclaration_details get_named_tag_predeclaration_details_by_id(struct asm_state *, struct named_tag_predeclaration_id);
struct scope_guid_id get_scope_guid_scope_guid_id_named_from_named_tag_predeclaration(struct named_tag_predeclaration_details);
struct identifier_id get_identifier_identifier_id_named_from_named_tag_predeclaration(struct named_tag_predeclaration_details);
void print_all_named_tag_definitions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_named_tag_definition(struct asm_state *, unsigned int, struct unsigned_char_list *, struct named_tag_definition_id);
struct named_tag_definition_details get_named_tag_definition_details_by_id(struct asm_state *, struct named_tag_definition_id);
struct tag_definition_id get_tag_definition_tag_definition_id_named_from_named_tag_definition(struct named_tag_definition_details);
struct scope_guid_id get_scope_guid_scope_guid_id_named_from_named_tag_definition(struct named_tag_definition_details);
struct identifier_id get_identifier_identifier_id_named_from_named_tag_definition(struct named_tag_definition_details);
void print_all_tag_definitions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_tag_definition(struct asm_state *, unsigned int, struct unsigned_char_list *, struct tag_definition_id);
struct tag_definition_details get_tag_definition_details_by_id(struct asm_state *, struct tag_definition_id);
struct enum_member_list_item_id get_enum_member_list_item_id_enum_from_tag_definition(struct tag_definition_details);
struct struct_or_union_member_list_item_id get_struct_or_union_member_list_item_id_struct_from_tag_definition(struct tag_definition_details);
struct struct_or_union_member_list_item_id get_struct_or_union_member_list_item_id_union_from_tag_definition(struct tag_definition_details);
void print_all_struct_or_union_member_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_struct_or_union_member_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct struct_or_union_member_list_item_id, unsigned int);
struct struct_or_union_member_list_item_details get_struct_or_union_member_list_item_details_by_id(struct asm_state *, struct struct_or_union_member_list_item_id);
struct struct_or_union_member_list_item_id get_struct_or_union_member_list_item_prev_id_member_from_struct_or_union_member_list_item(struct struct_or_union_member_list_item_details);
struct struct_or_union_member_id get_struct_or_union_member_item_id_member_from_struct_or_union_member_list_item(struct struct_or_union_member_list_item_details);
void print_all_enum_member_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_enum_member_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct enum_member_list_item_id, unsigned int);
struct enum_member_list_item_details get_enum_member_list_item_details_by_id(struct asm_state *, struct enum_member_list_item_id);
struct enum_member_list_item_id get_enum_member_list_item_prev_id_member_from_enum_member_list_item(struct enum_member_list_item_details);
struct enum_member_id get_enum_member_item_id_member_from_enum_member_list_item(struct enum_member_list_item_details);
void print_all_enum_members(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_enum_member(struct asm_state *, unsigned int, struct unsigned_char_list *, struct enum_member_id);
struct enum_member_details get_enum_member_details_by_id(struct asm_state *, struct enum_member_id);
struct identifier_id get_identifier_identifier_id_has_expression_from_enum_member(struct enum_member_details);
struct expression_id get_expression_expression_id_has_expression_from_enum_member(struct enum_member_details);
struct identifier_id get_identifier_identifier_id_no_expression_from_enum_member(struct enum_member_details);
void print_all_struct_or_union_members(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_struct_or_union_member(struct asm_state *, unsigned int, struct unsigned_char_list *, struct struct_or_union_member_id);
struct struct_or_union_member_details get_struct_or_union_member_details_by_id(struct asm_state *, struct struct_or_union_member_id);
struct general_type_id get_general_type_general_type_id_member_from_struct_or_union_member(struct struct_or_union_member_details);
struct identifier_id get_identifier_identifier_id_member_from_struct_or_union_member(struct struct_or_union_member_details);
struct general_type_id get_general_type_general_type_id_padding_from_struct_or_union_member(struct struct_or_union_member_details);
struct general_type_id get_general_type_general_type_id_c11_anonymous_member_from_struct_or_union_member(struct struct_or_union_member_details);
void print_all_initializers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_initializer(struct asm_state *, unsigned int, struct unsigned_char_list *, struct initializer_id);
struct initializer_details get_initializer_details_by_id(struct asm_state *, struct initializer_id);
struct initializer_list_item_id get_initializer_list_item_id_initializer_list_from_initializer(struct initializer_details);
struct expression_id get_expression_id_expression_from_initializer(struct initializer_details);
void print_all_initializer_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_initializer_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct initializer_list_item_id, unsigned int);
struct initializer_list_item_details get_initializer_list_item_details_by_id(struct asm_state *, struct initializer_list_item_id);
struct initializer_list_item_id get_initializer_list_item_prev_id_initializer_from_initializer_list_item(struct initializer_list_item_details);
struct initializer_id get_initializer_item_id_initializer_from_initializer_list_item(struct initializer_list_item_details);
void print_all_declarator_part_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_declarator_part_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct declarator_part_list_item_id, unsigned int);
struct declarator_part_list_item_details get_declarator_part_list_item_details_by_id(struct asm_state *, struct declarator_part_list_item_id);
struct declarator_part_list_item_id get_declarator_part_list_item_prev_id_declarator_part_from_declarator_part_list_item(struct declarator_part_list_item_details);
struct declarator_part_id get_declarator_part_item_id_declarator_part_from_declarator_part_list_item(struct declarator_part_list_item_details);
void print_all_pointer_parts(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_pointer_part(struct asm_state *, unsigned int, struct unsigned_char_list *, struct pointer_part_id);
struct pointer_part_details get_pointer_part_details_by_id(struct asm_state *, struct pointer_part_id);
struct specifier_or_qualifier_list_item_id get_specifier_or_qualifier_list_item_specifier_or_qualifier_list_item_id_pointer_from_pointer_part(struct pointer_part_details);
void print_all_function_parts(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_function_part(struct asm_state *, unsigned int, struct unsigned_char_list *, struct function_part_id);
struct function_part_details get_function_part_details_by_id(struct asm_state *, struct function_part_id);
struct parameter_list_id get_parameter_list_parameter_list_id_prototype_from_function_part(struct function_part_details);
struct parameter_list_id get_parameter_list_parameter_list_id_k_and_r_c_from_function_part(struct function_part_details);
void print_all_array_parts(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_array_part(struct asm_state *, unsigned int, struct unsigned_char_list *, struct array_part_id);
struct array_part_details get_array_part_details_by_id(struct asm_state *, struct array_part_id);
struct expression_id get_expression_expression_id_expression_from_array_part(struct array_part_details);
void print_all_general_types(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_general_type(struct asm_state *, unsigned int, struct unsigned_char_list *, struct general_type_id);
struct general_type_details get_general_type_details_by_id(struct asm_state *, struct general_type_id);
struct specifier_or_qualifier_list_item_id get_specifier_or_qualifier_list_item_specifier_or_qualifier_list_item_id_general_type_from_general_type(struct general_type_details);
struct declarator_part_list_item_id get_declarator_part_list_item_declarator_part_list_item_id_general_type_from_general_type(struct general_type_details);
struct bitfield_id get_bitfield_bitfield_id_general_type_from_general_type(struct general_type_details);
void print_all_identifier_namespace_entrys(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_identifier_namespace_entry(struct asm_state *, unsigned int, struct unsigned_char_list *, struct identifier_namespace_entry_id);
struct identifier_namespace_entry_details get_identifier_namespace_entry_details_by_id(struct asm_state *, struct identifier_namespace_entry_id);
struct identifier_id get_identifier_identifier_id_typedef_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
struct scope_guid_id get_scope_guid_scope_guid_id_typedef_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
struct general_type_id get_general_type_general_type_id_typedef_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
struct identifier_id get_identifier_identifier_id_declaration_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
struct scope_guid_id get_scope_guid_scope_guid_id_declaration_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
struct general_type_id get_general_type_general_type_id_declaration_from_identifier_namespace_entry(struct identifier_namespace_entry_details);
void print_all_general_type_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_general_type_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct general_type_list_item_id, unsigned int);
struct general_type_list_item_details get_general_type_list_item_details_by_id(struct asm_state *, struct general_type_list_item_id);
struct general_type_list_item_id get_general_type_list_item_prev_id_general_type_from_general_type_list_item(struct general_type_list_item_details);
struct general_type_id get_general_type_item_id_general_type_from_general_type_list_item(struct general_type_list_item_details);
void print_all_postfix_expression_part_list_items(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_postfix_expression_part_list_item(struct asm_state *, unsigned int, struct unsigned_char_list *, struct postfix_expression_part_list_item_id, unsigned int);
struct postfix_expression_part_list_item_details get_postfix_expression_part_list_item_details_by_id(struct asm_state *, struct postfix_expression_part_list_item_id);
struct postfix_expression_part_list_item_id get_postfix_expression_part_list_item_prev_id_postfix_expression_part_from_postfix_expression_part_list_item(struct postfix_expression_part_list_item_details);
struct postfix_expression_part_id get_postfix_expression_part_item_id_postfix_expression_part_from_postfix_expression_part_list_item(struct postfix_expression_part_list_item_details);
void print_all_postfix_expression_parts(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_postfix_expression_part(struct asm_state *, unsigned int, struct unsigned_char_list *, struct postfix_expression_part_id);
struct postfix_expression_part_details get_postfix_expression_part_details_by_id(struct asm_state *, struct postfix_expression_part_id);
struct expression_id get_expression_id_array_dereference_from_postfix_expression_part(struct postfix_expression_part_details);
struct identifier_id get_identifier_id_struct_dot_dereference_from_postfix_expression_part(struct postfix_expression_part_details);
struct identifier_id get_identifier_id_struct_arrow_dereference_from_postfix_expression_part(struct postfix_expression_part_details);
struct any_statement_list_item_id get_any_statement_list_item_id_function_dereference_from_postfix_expression_part(struct postfix_expression_part_details);
void print_all_unscoped_tag_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_unscoped_tag_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct unscoped_tag_specifier_id);
struct unscoped_tag_specifier_details get_unscoped_tag_specifier_details_by_id(struct asm_state *, struct unscoped_tag_specifier_id);
struct unscoped_struct_specifier_id get_unscoped_struct_specifier_id_struct_from_unscoped_tag_specifier(struct unscoped_tag_specifier_details);
struct unscoped_union_specifier_id get_unscoped_union_specifier_id_union_from_unscoped_tag_specifier(struct unscoped_tag_specifier_details);
struct unscoped_enum_specifier_id get_unscoped_enum_specifier_id_enum_from_unscoped_tag_specifier(struct unscoped_tag_specifier_details);
void print_all_scoped_typename_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_scoped_typename_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct scoped_typename_specifier_id);
struct scoped_typename_specifier_details get_scoped_typename_specifier_details_by_id(struct asm_state *, struct scoped_typename_specifier_id);
struct scope_guid_id get_scope_guid_scope_guid_id_scoped_typename_from_scoped_typename_specifier(struct scoped_typename_specifier_details);
struct identifier_id get_identifier_identifier_id_scoped_typename_from_scoped_typename_specifier(struct scoped_typename_specifier_details);
void print_all_scoped_tag_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_scoped_tag_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct scoped_tag_specifier_id);
struct scoped_tag_specifier_details get_scoped_tag_specifier_details_by_id(struct asm_state *, struct scoped_tag_specifier_id);
struct scope_guid_id get_scope_guid_scope_guid_id_scoped_tag_specifier_from_scoped_tag_specifier(struct scoped_tag_specifier_details);
struct unscoped_tag_specifier_id get_unscoped_tag_specifier_unscoped_tag_specifier_id_scoped_tag_specifier_from_scoped_tag_specifier(struct scoped_tag_specifier_details);
void print_all_unscoped_union_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_unscoped_union_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct unscoped_union_specifier_id);
struct unscoped_union_specifier_details get_unscoped_union_specifier_details_by_id(struct asm_state *, struct unscoped_union_specifier_id);
struct identifier_id get_identifier_id_named_from_unscoped_union_specifier(struct unscoped_union_specifier_details);
struct anonymous_entry_id get_anonymous_entry_id_anonymous_from_unscoped_union_specifier(struct unscoped_union_specifier_details);
void print_all_unscoped_struct_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_unscoped_struct_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct unscoped_struct_specifier_id);
struct unscoped_struct_specifier_details get_unscoped_struct_specifier_details_by_id(struct asm_state *, struct unscoped_struct_specifier_id);
struct identifier_id get_identifier_id_named_from_unscoped_struct_specifier(struct unscoped_struct_specifier_details);
struct anonymous_entry_id get_anonymous_entry_id_anonymous_from_unscoped_struct_specifier(struct unscoped_struct_specifier_details);
void print_all_unscoped_enum_specifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_unscoped_enum_specifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct unscoped_enum_specifier_id);
struct unscoped_enum_specifier_details get_unscoped_enum_specifier_details_by_id(struct asm_state *, struct unscoped_enum_specifier_id);
struct identifier_id get_identifier_id_named_from_unscoped_enum_specifier(struct unscoped_enum_specifier_details);
struct anonymous_entry_id get_anonymous_entry_id_anonymous_from_unscoped_enum_specifier(struct unscoped_enum_specifier_details);
void print_all_bitfields(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_bitfield(struct asm_state *, unsigned int, struct unsigned_char_list *, struct bitfield_id);
struct bitfield_details get_bitfield_details_by_id(struct asm_state *, struct bitfield_id);
struct expression_id get_expression_expression_id_constant_bitfield_from_bitfield(struct bitfield_details);
void print_all_jump_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_jump_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct jump_statement_id);
struct jump_statement_details get_jump_statement_details_by_id(struct asm_state *, struct jump_statement_id);
struct expression_id get_expression_id_return_expression_from_jump_statement(struct jump_statement_details);
struct identifier_id get_identifier_id_goto_from_jump_statement(struct jump_statement_details);
void print_all_switch_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_switch_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct switch_statement_id);
struct switch_statement_details get_switch_statement_details_by_id(struct asm_state *, struct switch_statement_id);
struct expression_id get_expression_e1_switch_from_switch_statement(struct switch_statement_details);
struct scoped_statement_id get_scoped_statement_s1_switch_from_switch_statement(struct switch_statement_details);
void print_all_if_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_if_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct if_statement_id);
struct if_statement_details get_if_statement_details_by_id(struct asm_state *, struct if_statement_id);
struct scoped_statement_id get_scoped_statement_s1_just_if_from_if_statement(struct if_statement_details);
struct expression_id get_expression_e1_just_if_from_if_statement(struct if_statement_details);
struct scoped_statement_id get_scoped_statement_s1_if_else_from_if_statement(struct if_statement_details);
struct expression_id get_expression_e1_if_else_from_if_statement(struct if_statement_details);
struct scoped_statement_id get_scoped_statement_s2_if_else_from_if_statement(struct if_statement_details);
void print_all_while_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_while_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct while_statement_id);
struct while_statement_details get_while_statement_details_by_id(struct asm_state *, struct while_statement_id);
struct expression_id get_expression_e1_do_while_from_while_statement(struct while_statement_details);
struct scoped_statement_id get_scoped_statement_s1_do_while_from_while_statement(struct while_statement_details);
struct expression_id get_expression_e1_while_from_while_statement(struct while_statement_details);
struct scoped_statement_id get_scoped_statement_s1_while_from_while_statement(struct while_statement_details);
void print_all_for_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_for_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct for_statement_id);
struct for_statement_details get_for_statement_details_by_id(struct asm_state *, struct for_statement_id);
struct any_statement_id get_any_statement_e1_for_from_for_statement(struct for_statement_details);
struct any_statement_id get_any_statement_e2_for_from_for_statement(struct for_statement_details);
struct any_statement_id get_any_statement_e3_for_from_for_statement(struct for_statement_details);
struct scoped_statement_id get_scoped_statement_s1_for_from_for_statement(struct for_statement_details);
void print_all_code_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_code_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct code_statement_id);
struct code_statement_details get_code_statement_details_by_id(struct asm_state *, struct code_statement_id);
struct labeled_statement_id get_labeled_statement_id_labeled_statement_from_code_statement(struct code_statement_details);
struct any_statement_list_item_id get_any_statement_list_item_id_compound_statement_from_code_statement(struct code_statement_details);
struct expression_id get_expression_id_expression_statement_from_code_statement(struct code_statement_details);
struct for_statement_id get_for_statement_id_for_statement_from_code_statement(struct code_statement_details);
struct while_statement_id get_while_statement_id_while_statement_from_code_statement(struct code_statement_details);
struct if_statement_id get_if_statement_id_if_statement_from_code_statement(struct code_statement_details);
struct switch_statement_id get_switch_statement_id_switch_statement_from_code_statement(struct code_statement_details);
struct jump_statement_id get_jump_statement_id_jump_statement_from_code_statement(struct code_statement_details);
void print_all_labeled_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_labeled_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct labeled_statement_id);
struct labeled_statement_details get_labeled_statement_details_by_id(struct asm_state *, struct labeled_statement_id);
struct scoped_statement_id get_scoped_statement_scoped_statement_id_goto_label_from_labeled_statement(struct labeled_statement_details);
struct identifier_id get_identifier_id_goto_label_from_labeled_statement(struct labeled_statement_details);
struct scoped_statement_id get_scoped_statement_scoped_statement_id_case_label_from_labeled_statement(struct labeled_statement_details);
struct expression_id get_expression_id_case_label_from_labeled_statement(struct labeled_statement_details);
struct scoped_statement_id get_scoped_statement_scoped_statement_id_default_label_from_labeled_statement(struct labeled_statement_details);
void print_all_postfix_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_postfix_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct postfix_expression_id);
struct postfix_expression_details get_postfix_expression_details_by_id(struct asm_state *, struct postfix_expression_id);
struct primary_expression_id get_primary_expression_primary_expression_id_postfix_expression_from_postfix_expression(struct postfix_expression_details);
struct postfix_expression_part_list_item_id get_postfix_expression_part_list_item_postfix_expression_part_list_item_id_postfix_expression_from_postfix_expression(struct postfix_expression_details);
void print_all_primary_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_primary_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct primary_expression_id);
struct primary_expression_details get_primary_expression_details_by_id(struct asm_state *, struct primary_expression_id);
struct constant_description_id get_constant_description_id_constant_description_from_primary_expression(struct primary_expression_details);
struct identifier_id get_identifier_id_identifier_from_primary_expression(struct primary_expression_details);
struct scope_guid_id get_scope_guid_scope_guid_id_identifier_from_primary_expression(struct primary_expression_details);
struct expression_id get_expression_id_expression_from_primary_expression(struct primary_expression_details);
void print_all_any_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_any_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct any_statement_id);
struct any_statement_details get_any_statement_details_by_id(struct asm_state *, struct any_statement_id);
struct declaration_statement_id get_declaration_statement_id_declaration_statement_from_any_statement(struct any_statement_details);
struct scoped_statement_id get_scoped_statement_id_scoped_statement_from_any_statement(struct any_statement_details);
struct code_statement_id get_code_statement_id_code_statement_from_any_statement(struct any_statement_details);
void print_all_scoped_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_scoped_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct scoped_statement_id);
struct scoped_statement_details get_scoped_statement_details_by_id(struct asm_state *, struct scoped_statement_id);
struct any_statement_list_item_id get_any_statement_list_item_any_statement_list_item_id_scoped_statement_from_scoped_statement(struct scoped_statement_details);
struct scope_guid_id get_scope_guid_scope_guid_id_scoped_statement_from_scoped_statement(struct scoped_statement_details);
void print_all_declaration_statements(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_declaration_statement(struct asm_state *, unsigned int, struct unsigned_char_list *, struct declaration_statement_id);
struct declaration_statement_details get_declaration_statement_details_by_id(struct asm_state *, struct declaration_statement_id);
struct simple_declaration_id get_simple_declaration_id_simple_declaration_from_declaration_statement(struct declaration_statement_details);
struct function_definition_id get_function_definition_id_function_definition_from_declaration_statement(struct declaration_statement_details);
void print_all_function_definitions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_function_definition(struct asm_state *, unsigned int, struct unsigned_char_list *, struct function_definition_id);
struct function_definition_details get_function_definition_details_by_id(struct asm_state *, struct function_definition_id);
struct general_type_id get_general_type_general_type_id_function_definition_from_function_definition(struct function_definition_details);
struct any_statement_list_item_id get_any_statement_list_item_k_and_r_declarations_function_definition_from_function_definition(struct function_definition_details);
struct any_statement_list_item_id get_any_statement_list_item_params_function_definition_from_function_definition(struct function_definition_details);
struct scoped_statement_id get_scoped_statement_body_function_definition_from_function_definition(struct function_definition_details);
struct identifier_id get_identifier_identifier_id_function_definition_from_function_definition(struct function_definition_details);
void print_all_simple_declarations(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_simple_declaration(struct asm_state *, unsigned int, struct unsigned_char_list *, struct simple_declaration_id);
struct simple_declaration_details get_simple_declaration_details_by_id(struct asm_state *, struct simple_declaration_id);
struct general_type_id get_general_type_general_type_id_simple_declaration_from_simple_declaration(struct simple_declaration_details);
struct identifier_id get_identifier_identifier_id_simple_declaration_from_simple_declaration(struct simple_declaration_details);
struct initializer_id get_initializer_initializer_id_simple_declaration_from_simple_declaration(struct simple_declaration_details);
void print_all_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct expression_id);
struct expression_details get_expression_details_by_id(struct asm_state *, struct expression_id);
struct cast_expression_id get_cast_expression_id_cast_expression_from_expression(struct expression_details);
struct binary_expression_id get_binary_expression_id_binary_expression_from_expression(struct expression_details);
struct ternary_expression_id get_ternary_expression_id_ternary_expression_from_expression(struct expression_details);
void print_all_cast_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_cast_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct cast_expression_id);
struct cast_expression_details get_cast_expression_details_by_id(struct asm_state *, struct cast_expression_id);
struct cast_expression_id get_cast_expression_id1_has_cast_from_cast_expression(struct cast_expression_details);
struct general_type_id get_general_type_id2_has_cast_from_cast_expression(struct cast_expression_details);
struct unary_expression_id get_unary_expression_id1_no_cast_from_cast_expression(struct cast_expression_details);
void print_all_unary_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_unary_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct unary_expression_id);
struct unary_expression_details get_unary_expression_details_by_id(struct asm_state *, struct unary_expression_id);
struct expression_id get_expression_id1_sizeof_expression_from_unary_expression(struct unary_expression_details);
struct postfix_expression_id get_postfix_expression_id1_postfix_expression_from_unary_expression(struct unary_expression_details);
struct general_type_id get_general_type_id1_sizeof_type_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_increment_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_decrement_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_address_of_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_point_to_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_plus_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_minus_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_bitwise_not_from_unary_expression(struct unary_expression_details);
struct expression_id get_expression_id1_logical_not_from_unary_expression(struct unary_expression_details);
void print_all_binary_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_binary_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct binary_expression_id);
struct binary_expression_details get_binary_expression_details_by_id(struct asm_state *, struct binary_expression_id);
struct expression_id get_expression_e1_comma_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_comma_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_plus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_plus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_minus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_minus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_divide_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_divide_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_multiply_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_multiply_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_exclusive_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_exclusive_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_modulus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_modulus_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_right_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_right_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_left_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_left_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_bitwise_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_bitwise_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_logical_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_logical_or_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_bitwise_and_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_bitwise_and_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_logical_and_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_logical_and_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_lt_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_lt_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_gt_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_gt_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_le_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_le_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_ge_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_ge_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_eq_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_eq_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_ne_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_ne_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_add_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_add_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_sub_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_sub_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_div_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_div_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_mul_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_mul_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_and_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_and_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_or_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_or_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_xor_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_xor_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_mod_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_mod_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_right_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_right_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e1_left_assign_from_binary_expression(struct binary_expression_details);
struct expression_id get_expression_e2_left_assign_from_binary_expression(struct binary_expression_details);
void print_all_ternary_expressions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_ternary_expression(struct asm_state *, unsigned int, struct unsigned_char_list *, struct ternary_expression_id);
struct ternary_expression_details get_ternary_expression_details_by_id(struct asm_state *, struct ternary_expression_id);
struct expression_id get_expression_e1_ternary_operator_from_ternary_expression(struct ternary_expression_details);
struct expression_id get_expression_e2_ternary_operator_from_ternary_expression(struct ternary_expression_details);
struct expression_id get_expression_e3_ternary_operator_from_ternary_expression(struct ternary_expression_details);
void print_all_constant_descriptions(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_constant_description(struct asm_state *, unsigned int, struct unsigned_char_list *, struct constant_description_id);
struct constant_description_details get_constant_description_details_by_id(struct asm_state *, struct constant_description_id);
struct general_type_id get_general_type_general_type_id_constant_description_from_constant_description(struct constant_description_details);
struct data_package_id get_data_package_data_package_id_constant_description_from_constant_description(struct constant_description_details);
void print_all_data_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_data_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct data_package_id);
struct data_package_details get_data_package_details_by_id(struct asm_state *, struct data_package_id);
struct error_node_id get_error_node_id_error_from_data_package(struct data_package_details);
struct byte_package_id get_byte_package_id_byte_from_data_package(struct data_package_details);
struct hword_package_id get_hword_package_id_hword_from_data_package(struct data_package_details);
struct word_package_id get_word_package_id_word_from_data_package(struct data_package_details);
struct dword_package_id get_dword_package_id_dword_from_data_package(struct data_package_details);
struct qword_package_id get_qword_package_id_qword_from_data_package(struct data_package_details);
struct string_package_id get_string_package_id_string_from_data_package(struct data_package_details);
void print_all_error_nodes(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_error_node(struct asm_state *, unsigned int, struct unsigned_char_list *, struct error_node_id);
struct error_node_details get_error_node_details_by_id(struct asm_state *, struct error_node_id);
void print_all_byte_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_byte_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct byte_package_id);
struct byte_package_details get_byte_package_details_by_id(struct asm_state *, struct byte_package_id);
void print_all_hword_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_hword_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct hword_package_id);
struct hword_package_details get_hword_package_details_by_id(struct asm_state *, struct hword_package_id);
void print_all_word_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_word_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct word_package_id);
struct word_package_details get_word_package_details_by_id(struct asm_state *, struct word_package_id);
void print_all_qword_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_qword_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct qword_package_id);
struct qword_package_details get_qword_package_details_by_id(struct asm_state *, struct qword_package_id);
void print_all_dword_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_dword_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct dword_package_id);
struct dword_package_details get_dword_package_details_by_id(struct asm_state *, struct dword_package_id);
void print_all_string_packages(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_string_package(struct asm_state *, unsigned int, struct unsigned_char_list *, struct string_package_id);
struct string_package_details get_string_package_details_by_id(struct asm_state *, struct string_package_id);
void print_all_identifiers(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_identifier(struct asm_state *, unsigned int, struct unsigned_char_list *, struct identifier_id);
struct identifier_details get_identifier_details_by_id(struct asm_state *, struct identifier_id);
void print_all_scope_guids(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_scope_guid(struct asm_state *, unsigned int, struct unsigned_char_list *, struct scope_guid_id);
struct scope_guid_details get_scope_guid_details_by_id(struct asm_state *, struct scope_guid_id);
struct scope_guid_id get_scope_guid_parent_block_scope_from_scope_guid(struct scope_guid_details);
struct scope_guid_id get_scope_guid_parent_function_scope_from_scope_guid(struct scope_guid_details);
struct scope_guid_id get_scope_guid_parent_function_prototype_scope_from_scope_guid(struct scope_guid_details);
void print_all_anonymous_entrys(struct asm_state * state, unsigned int indent_depth, struct unsigned_char_list * out);
void print_anonymous_entry(struct asm_state *, unsigned int, struct unsigned_char_list *, struct anonymous_entry_id);
struct anonymous_entry_details get_anonymous_entry_details_by_id(struct asm_state *, struct anonymous_entry_id);
struct aggregate_type_specifier_id make_aggregate_type_specifier_simple_type_specifier(struct asm_state *, struct simple_type_specifier_id);
struct aggregate_type_specifier_id make_aggregate_type_specifier_tag_specifier(struct asm_state *, struct scoped_tag_specifier_id);
struct aggregate_type_specifier_id make_aggregate_type_specifier_typename_specifier(struct asm_state *, struct scoped_typename_specifier_id);
struct simple_type_specifier_id make_simple_type_specifier_void(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_char(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_short(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_int(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_long(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_float(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_double(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_signed(struct asm_state *);
struct simple_type_specifier_id make_simple_type_specifier_unsigned(struct asm_state *);
struct simple_type_qualifier_id make_simple_type_qualifier_const(struct asm_state *);
struct simple_type_qualifier_id make_simple_type_qualifier_volatile(struct asm_state *);
struct simple_storage_class_specifier_id make_simple_storage_class_specifier_typedef(struct asm_state *);
struct simple_storage_class_specifier_id make_simple_storage_class_specifier_extern(struct asm_state *);
struct simple_storage_class_specifier_id make_simple_storage_class_specifier_static(struct asm_state *);
struct simple_storage_class_specifier_id make_simple_storage_class_specifier_auto(struct asm_state *);
struct simple_storage_class_specifier_id make_simple_storage_class_specifier_register(struct asm_state *);
struct specifier_or_qualifier_id make_specifier_or_qualifier_simple_storage_class_specifier(struct asm_state *, struct simple_storage_class_specifier_id);
struct specifier_or_qualifier_id make_specifier_or_qualifier_simple_type_qualifier(struct asm_state *, struct simple_type_qualifier_id);
struct specifier_or_qualifier_id make_specifier_or_qualifier_aggregate_type_specifier(struct asm_state *, struct aggregate_type_specifier_id);
struct specifier_or_qualifier_list_item_id make_specifier_or_qualifier_list_item_specifier_or_qualifier(struct asm_state *, struct specifier_or_qualifier_list_item_id, struct specifier_or_qualifier_id);
struct specifier_or_qualifier_list_item_id make_specifier_or_qualifier_list_item_list_start(struct asm_state *);
struct parameter_list_id make_parameter_list_variadic(struct asm_state *, struct general_type_list_item_id);
struct parameter_list_id make_parameter_list_non_variadic(struct asm_state *, struct general_type_list_item_id);
struct declarator_part_id make_declarator_part_function(struct asm_state *, struct function_part_id);
struct declarator_part_id make_declarator_part_pointer(struct asm_state *, struct pointer_part_id);
struct declarator_part_id make_declarator_part_array(struct asm_state *, struct array_part_id);
struct any_statement_list_item_id make_any_statement_list_item_any_statement(struct asm_state *, struct any_statement_list_item_id, struct any_statement_id);
struct any_statement_list_item_id make_any_statement_list_item_list_start(struct asm_state *);
struct anonymous_tag_definition_id make_anonymous_tag_definition_anonymous(struct asm_state *, struct tag_definition_id, struct scope_guid_id, struct anonymous_entry_id);
struct named_tag_predeclaration_id make_named_tag_predeclaration_named(struct asm_state *, struct scope_guid_id, struct identifier_id, enum asm_unscoped_tag_specifier_kind, unsigned int);
struct named_tag_definition_id make_named_tag_definition_named(struct asm_state *, struct tag_definition_id, struct scope_guid_id, struct identifier_id, unsigned int);
struct tag_definition_id make_tag_definition_enum(struct asm_state *, struct enum_member_list_item_id);
struct tag_definition_id make_tag_definition_struct(struct asm_state *, struct struct_or_union_member_list_item_id);
struct tag_definition_id make_tag_definition_union(struct asm_state *, struct struct_or_union_member_list_item_id);
struct struct_or_union_member_list_item_id make_struct_or_union_member_list_item_member(struct asm_state *, struct struct_or_union_member_list_item_id, struct struct_or_union_member_id);
struct struct_or_union_member_list_item_id make_struct_or_union_member_list_item_list_start(struct asm_state *);
struct enum_member_list_item_id make_enum_member_list_item_member(struct asm_state *, struct enum_member_list_item_id, struct enum_member_id);
struct enum_member_list_item_id make_enum_member_list_item_list_start(struct asm_state *);
struct enum_member_id make_enum_member_has_expression(struct asm_state *, struct identifier_id, struct expression_id);
struct enum_member_id make_enum_member_no_expression(struct asm_state *, struct identifier_id);
struct struct_or_union_member_id make_struct_or_union_member_member(struct asm_state *, struct general_type_id, struct identifier_id);
struct struct_or_union_member_id make_struct_or_union_member_padding(struct asm_state *, struct general_type_id);
struct struct_or_union_member_id make_struct_or_union_member_c11_anonymous_member(struct asm_state *, struct general_type_id);
struct initializer_id make_initializer_initializer_list(struct asm_state *, struct initializer_list_item_id);
struct initializer_id make_initializer_no_initializer(struct asm_state *);
struct initializer_id make_initializer_expression(struct asm_state *, struct expression_id);
struct initializer_list_item_id make_initializer_list_item_initializer(struct asm_state *, struct initializer_list_item_id, struct initializer_id);
struct initializer_list_item_id make_initializer_list_item_list_start(struct asm_state *);
struct declarator_part_list_item_id make_declarator_part_list_item_declarator_part(struct asm_state *, struct declarator_part_list_item_id, struct declarator_part_id);
struct declarator_part_list_item_id make_declarator_part_list_item_list_start(struct asm_state *);
struct pointer_part_id make_pointer_part_pointer(struct asm_state *, struct specifier_or_qualifier_list_item_id);
struct function_part_id make_function_part_prototype(struct asm_state *, struct parameter_list_id);
struct function_part_id make_function_part_k_and_r_c(struct asm_state *, struct parameter_list_id);
struct array_part_id make_array_part_expression(struct asm_state *, struct expression_id);
struct array_part_id make_array_part_flexible(struct asm_state *);
struct general_type_id make_general_type_general_type(struct asm_state *, struct specifier_or_qualifier_list_item_id, struct declarator_part_list_item_id, struct bitfield_id);
struct identifier_namespace_entry_id make_identifier_namespace_entry_typedef(struct asm_state *, struct identifier_id, struct scope_guid_id, struct general_type_id, unsigned int);
struct identifier_namespace_entry_id make_identifier_namespace_entry_declaration(struct asm_state *, struct identifier_id, struct scope_guid_id, struct general_type_id, unsigned int);
struct general_type_list_item_id make_general_type_list_item_general_type(struct asm_state *, struct general_type_list_item_id, struct general_type_id);
struct general_type_list_item_id make_general_type_list_item_list_start(struct asm_state *);
struct postfix_expression_part_list_item_id make_postfix_expression_part_list_item_postfix_expression_part(struct asm_state *, struct postfix_expression_part_list_item_id, struct postfix_expression_part_id);
struct postfix_expression_part_list_item_id make_postfix_expression_part_list_item_list_start(struct asm_state *);
struct postfix_expression_part_id make_postfix_expression_part_array_dereference(struct asm_state *, struct expression_id);
struct postfix_expression_part_id make_postfix_expression_part_struct_dot_dereference(struct asm_state *, struct identifier_id);
struct postfix_expression_part_id make_postfix_expression_part_struct_arrow_dereference(struct asm_state *, struct identifier_id);
struct postfix_expression_part_id make_postfix_expression_part_function_dereference(struct asm_state *, struct any_statement_list_item_id);
struct postfix_expression_part_id make_postfix_expression_part_inc(struct asm_state *);
struct postfix_expression_part_id make_postfix_expression_part_dec(struct asm_state *);
struct unscoped_tag_specifier_id make_unscoped_tag_specifier_struct(struct asm_state *, struct unscoped_struct_specifier_id);
struct unscoped_tag_specifier_id make_unscoped_tag_specifier_union(struct asm_state *, struct unscoped_union_specifier_id);
struct unscoped_tag_specifier_id make_unscoped_tag_specifier_enum(struct asm_state *, struct unscoped_enum_specifier_id);
struct scoped_typename_specifier_id make_scoped_typename_specifier_scoped_typename(struct asm_state *, struct scope_guid_id, struct identifier_id);
struct scoped_tag_specifier_id make_scoped_tag_specifier_scoped_tag_specifier(struct asm_state *, struct scope_guid_id, struct unscoped_tag_specifier_id);
struct unscoped_union_specifier_id make_unscoped_union_specifier_named(struct asm_state *, struct identifier_id);
struct unscoped_union_specifier_id make_unscoped_union_specifier_anonymous(struct asm_state *, struct anonymous_entry_id);
struct unscoped_struct_specifier_id make_unscoped_struct_specifier_named(struct asm_state *, struct identifier_id);
struct unscoped_struct_specifier_id make_unscoped_struct_specifier_anonymous(struct asm_state *, struct anonymous_entry_id);
struct unscoped_enum_specifier_id make_unscoped_enum_specifier_named(struct asm_state *, struct identifier_id);
struct unscoped_enum_specifier_id make_unscoped_enum_specifier_anonymous(struct asm_state *, struct anonymous_entry_id);
struct bitfield_id make_bitfield_no_bitfield(struct asm_state *);
struct bitfield_id make_bitfield_constant_bitfield(struct asm_state *, struct expression_id);
struct jump_statement_id make_jump_statement_return_expression(struct asm_state *, struct expression_id);
struct jump_statement_id make_jump_statement_return_no_expression(struct asm_state *);
struct jump_statement_id make_jump_statement_break(struct asm_state *);
struct jump_statement_id make_jump_statement_continue(struct asm_state *);
struct jump_statement_id make_jump_statement_goto(struct asm_state *, struct identifier_id);
struct switch_statement_id make_switch_statement_switch(struct asm_state *, struct expression_id, struct scoped_statement_id);
struct if_statement_id make_if_statement_just_if(struct asm_state *, struct scoped_statement_id, struct expression_id);
struct if_statement_id make_if_statement_if_else(struct asm_state *, struct scoped_statement_id, struct expression_id, struct scoped_statement_id);
struct while_statement_id make_while_statement_do_while(struct asm_state *, struct expression_id, struct scoped_statement_id);
struct while_statement_id make_while_statement_while(struct asm_state *, struct expression_id, struct scoped_statement_id);
struct for_statement_id make_for_statement_for(struct asm_state *, struct any_statement_id, struct any_statement_id, struct any_statement_id, struct scoped_statement_id);
struct code_statement_id make_code_statement_labeled_statement(struct asm_state *, struct labeled_statement_id);
struct code_statement_id make_code_statement_compound_statement(struct asm_state *, struct any_statement_list_item_id);
struct code_statement_id make_code_statement_expression_statement(struct asm_state *, struct expression_id);
struct code_statement_id make_code_statement_for_statement(struct asm_state *, struct for_statement_id);
struct code_statement_id make_code_statement_while_statement(struct asm_state *, struct while_statement_id);
struct code_statement_id make_code_statement_if_statement(struct asm_state *, struct if_statement_id);
struct code_statement_id make_code_statement_switch_statement(struct asm_state *, struct switch_statement_id);
struct code_statement_id make_code_statement_jump_statement(struct asm_state *, struct jump_statement_id);
struct labeled_statement_id make_labeled_statement_goto_label(struct asm_state *, struct scoped_statement_id, struct identifier_id);
struct labeled_statement_id make_labeled_statement_case_label(struct asm_state *, struct scoped_statement_id, struct expression_id);
struct labeled_statement_id make_labeled_statement_default_label(struct asm_state *, struct scoped_statement_id);
struct postfix_expression_id make_postfix_expression_postfix_expression(struct asm_state *, struct primary_expression_id, struct postfix_expression_part_list_item_id);
struct primary_expression_id make_primary_expression_constant_description(struct asm_state *, struct constant_description_id);
struct primary_expression_id make_primary_expression_identifier(struct asm_state *, struct identifier_id, struct scope_guid_id);
struct primary_expression_id make_primary_expression_expression(struct asm_state *, struct expression_id);
struct any_statement_id make_any_statement_declaration_statement(struct asm_state *, struct declaration_statement_id);
struct any_statement_id make_any_statement_scoped_statement(struct asm_state *, struct scoped_statement_id);
struct any_statement_id make_any_statement_code_statement(struct asm_state *, struct code_statement_id);
struct scoped_statement_id make_scoped_statement_scoped_statement(struct asm_state *, struct any_statement_list_item_id, struct scope_guid_id);
struct declaration_statement_id make_declaration_statement_simple_declaration(struct asm_state *, struct simple_declaration_id);
struct declaration_statement_id make_declaration_statement_function_definition(struct asm_state *, struct function_definition_id);
struct function_definition_id make_function_definition_function_definition(struct asm_state *, struct general_type_id, struct any_statement_list_item_id, struct any_statement_list_item_id, struct scoped_statement_id, struct identifier_id);
struct simple_declaration_id make_simple_declaration_simple_declaration(struct asm_state *, struct general_type_id, struct identifier_id, struct initializer_id);
struct expression_id make_expression_nullary_expression(struct asm_state *);
struct expression_id make_expression_cast_expression(struct asm_state *, struct cast_expression_id);
struct expression_id make_expression_binary_expression(struct asm_state *, struct binary_expression_id);
struct expression_id make_expression_ternary_expression(struct asm_state *, struct ternary_expression_id);
struct cast_expression_id make_cast_expression_has_cast(struct asm_state *, struct cast_expression_id, struct general_type_id);
struct cast_expression_id make_cast_expression_no_cast(struct asm_state *, struct unary_expression_id);
struct unary_expression_id make_unary_expression_sizeof_expression(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_postfix_expression(struct asm_state *, struct postfix_expression_id);
struct unary_expression_id make_unary_expression_sizeof_type(struct asm_state *, struct general_type_id);
struct unary_expression_id make_unary_expression_increment(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_decrement(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_address_of(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_point_to(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_plus(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_minus(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_bitwise_not(struct asm_state *, struct expression_id);
struct unary_expression_id make_unary_expression_logical_not(struct asm_state *, struct expression_id);
struct binary_expression_id make_binary_expression_comma(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_plus(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_minus(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_divide(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_multiply(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_exclusive_or(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_modulus(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_right(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_left(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_bitwise_or(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_logical_or(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_bitwise_and(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_logical_and(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_lt(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_gt(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_le(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_ge(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_eq(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_ne(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_add_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_sub_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_div_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_mul_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_and_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_or_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_xor_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_mod_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_right_assign(struct asm_state *, struct expression_id, struct expression_id);
struct binary_expression_id make_binary_expression_left_assign(struct asm_state *, struct expression_id, struct expression_id);
struct ternary_expression_id make_ternary_expression_ternary_operator(struct asm_state *, struct expression_id, struct expression_id, struct expression_id);
struct constant_description_id make_constant_description_constant_description(struct asm_state *, struct general_type_id, struct data_package_id);
struct data_package_id make_data_package_error(struct asm_state *, struct error_node_id);
struct data_package_id make_data_package_byte(struct asm_state *, struct byte_package_id);
struct data_package_id make_data_package_hword(struct asm_state *, struct hword_package_id);
struct data_package_id make_data_package_word(struct asm_state *, struct word_package_id);
struct data_package_id make_data_package_dword(struct asm_state *, struct dword_package_id);
struct data_package_id make_data_package_qword(struct asm_state *, struct qword_package_id);
struct data_package_id make_data_package_string(struct asm_state *, struct string_package_id);
struct error_node_id make_error_node_error(struct asm_state *);
struct byte_package_id make_byte_package_byte(struct asm_state *, unsigned char);
struct hword_package_id make_hword_package_hword(struct asm_state *, unsigned char, unsigned char);
struct word_package_id make_word_package_word(struct asm_state *, unsigned int);
struct qword_package_id make_qword_package_qword(struct asm_state *, unsigned int, unsigned int, unsigned int, unsigned int);
struct dword_package_id make_dword_package_dword(struct asm_state *, unsigned int, unsigned int);
struct string_package_id make_string_package_string(struct asm_state *, unsigned int, unsigned int, unsigned int *);
struct identifier_id make_identifier_identifier(struct asm_state *, struct c_lexer_token *);
struct scope_guid_id make_scope_guid_block_scope(struct asm_state *, struct scope_guid_id);
struct scope_guid_id make_scope_guid_file_scope(struct asm_state *);
struct scope_guid_id make_scope_guid_function_scope(struct asm_state *, struct scope_guid_id);
struct scope_guid_id make_scope_guid_function_prototype_scope(struct asm_state *, struct scope_guid_id);
struct anonymous_entry_id make_anonymous_entry_anonymous_entry(struct asm_state *);
#endif
