

/*
    Copyright 2016 Robert Elder Software Inc.
    
    Licensed under the Apache License, Version 2.0 (the "License"); you may not 
    use this file except in compliance with the License.  You may obtain a copy 
    of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
    License for the specific language governing permissions and limitations 
    under the License.
*/

enum parser_error_type{
	PARSER_ERROR_INCOMPLETE_PARSE,
	PARSER_ERROR_PARSING_FAILED,
	PARSER_ERROR_ARGUMENT_EXPRESSION_LIST_MISSING_ARGUMENT,
	PARSER_ERROR_ARGUMENT_EXPRESSION_LIST_REST_MISSING_ARGUMENT,
	PARSER_ERROR_ARGUMENT_EXPRESSION_LIST_REST_MISSING_ASSIGNMENT_EXPRESSION,
	PARSER_ERROR_INIT_DECLARATOR_MISSING_INITIALIZER,
	PARSER_ERROR_PRIMARY_EXPRESSION_MISSING_CLOSE_PAREN,
	PARSER_ERROR_STRUCT_OR_UNION_SPECIFIER_NO_DECLARATIONS,
	PARSER_ERROR_STRUCT_OR_UNION_SPECIFIER_MISSING_BRACE,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_ARRAY_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_ARRAY_EXPRESSION_INCOMPLETE,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_ARRAY_EXPRESSION_MISSING,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_0_ARGS_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_SOME_ARGS_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_SOME_ARGS_NO_CLOSE,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_0_ARGS_NO_CLOSE,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_DOT_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_DOT_NO_IDENTIFIER,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_PTR_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_PTR_NO_IDENTIFIER,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_INC_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_REST_DEC_NO_REST,
	PARSER_ERROR_POSTFIX_EXPRESSION_NO_REST,
	PARSER_ERROR_UNARY_EXPRESSION_AFTER_INC,
	PARSER_ERROR_UNARY_EXPRESSION_AFTER_DEC,
	PARSER_ERROR_UNARY_EXPRESSION_MISSING_CAST,
	PARSER_ERROR_UNARY_EXPRESSION_MISSING_PAREN,
	PARSER_ERROR_UNARY_EXPRESSION_MISSING_TYPE,
	PARSER_ERROR_UNARY_EXPRESSION_BAD_SIZEOF,
	PARSER_ERROR_CAST_EXPRESSION_MISSING_CAST,
	PARSER_ERROR_CAST_EXPRESSION_MISSING_CLOSE_PAREN,
	PARSER_ERROR_CAST_EXPRESSION_MISSING_TYPE_NAME,
	PARSER_ERROR_MULTIPLICATIVE_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_MULTIPLICATIVE_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_ADDITIVE_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_ADDITIVE_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_ADDITIVE_EXPRESSION_NO_REST,
	PARSER_ERROR_SHIFT_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_SHIFT_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_SHIFT_EXPRESSION_NO_REST,
	PARSER_ERROR_RELATIONAL_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_RELATIONAL_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_RELATIONAL_EXPRESSION_NO_REST,
	PARSER_ERROR_EQUALITY_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_EQUALITY_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_EQUALITY_EXPRESSION_NO_REST,
	PARSER_ERROR_AND_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_AND_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_AND_EXPRESSION_NO_REST,
	PARSER_ERROR_EXCLUSIVE_OR_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_EXCLUSIVE_OR_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_EXCLUSIVE_OR_EXPRESSION_NO_REST,
	PARSER_ERROR_INCLUSIVE_OR_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_INCLUSIVE_OR_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_INCLUSIVE_OR_EXPRESSION_NO_REST,
	PARSER_ERROR_LOGICAL_AND_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_LOGICAL_AND_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_LOGICAL_AND_EXPRESSION_NO_REST,
	PARSER_ERROR_LOGICAL_OR_EXPRESSION_REST_EXPECTED_EXPRESSION,
	PARSER_ERROR_LOGICAL_OR_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_LOGICAL_OR_EXPRESSION_NO_REST,
	PARSER_ERROR_COMPOUND_STATEMENT_MISSING_BRACE_1,
	PARSER_ERROR_COMPOUND_STATEMENT_MISSING_BRACE_2,
	PARSER_ERROR_COMPOUND_STATEMENT_MISSING_BRACE_3,
	PARSER_ERROR_COMPOUND_STATEMENT_MISSING_BRACE_4,
	PARSER_ERROR_CONDITIONAL_EXPRESSION_MISSING_FALSE,
	PARSER_ERROR_CONDITIONAL_EXPRESSION_MISSING_COLON,
	PARSER_ERROR_CONDITIONAL_EXPRESSION_MISSING_TRUE,
	PARSER_ERROR_EXPRESSION_REST_NO_REST,
	PARSER_ERROR_EXPRESSION_REST_NO_ASSIGNMENT_EXPRESSION,
	PARSER_ERROR_EXPRESSION_NO_REST,
	PARSER_ERROR_ENUM_SPECIFIER_MISSING_OPEN_BRACE_OR_IDENTIFIER,
	PARSER_ERROR_ENUM_SPECIFIER_MISSING_ENUMERATOR_LIST_NAMED,
	PARSER_ERROR_ENUM_SPECIFIER_MISSING_CLOSE_BRACE_NAMED,
	PARSER_ERROR_ENUM_SPECIFIER_MISSING_ENUMERATOR_LIST_ANON,
	PARSER_ERROR_ENUM_SPECIFIER_MISSING_CLOSE_BRACE_ANON,
	PARSER_ERROR_ENUMERATOR_LIST_MISSING_REST,
	PARSER_ERROR_ENUMERATOR_LIST_REST_MISSING_ENUMERATOR,
	PARSER_ERROR_ENUMERATOR_LIST_REST_MISSING_REST,
	PARSER_ERROR_ENUMERATOR_MISSING_CONSTANT_EXPRESSION,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_REST_AFTER_ARRAY_SIZED,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_CLOSE_BRACKET_AFTER_CONSTANT,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_REST_AFTER_ARRAY_UNSIZED,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_CLOSE_OR_CONSTANT,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_REST_AFTER_PARAM_FUNCTION,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_CLOSE_PAREN_AFTER_PARAM,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_REST_AFTER_IDENTIFIER_FUNCTION,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_CLOSE_PAREN_AFTER_IDENTIFIER_LIST,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_REST_AFTER_KR_FUNCTION,
	PARSER_ERROR_DIRECT_DECLARATOR_REST_MISSING_CLOSE_PAREN,
	PARSER_ERROR_DIRECT_DECLARATOR_MISSING_REST_AFTER_IDENTIFIER,
	PARSER_ERROR_DIRECT_DECLARATOR_MISSING_REST_AFTER_CLOSE_PAREN,
	PARSER_ERROR_DIRECT_DECLARATOR_MISSING_CLOSE_PAREN,
	PARSER_ERROR_INITIALIZER_MISSING_CLOSE_BRACE,
	PARSER_ERROR_INITIALIZER_MISSING_COMMA_OR_CLOSE_BRACE,
	PARSER_ERROR_INITIALIZER_MISSING_INITIALIZER_LIST,
	PARSER_ERROR_STRUCT_DECLARATOR_MISSING_CONSTANT_AFTER_DECLARATOR,
	PARSER_ERROR_STRUCT_DECLARATOR_MISSING_CONSTANT_NO_DECLARATOR,
	PARSER_ERROR_STRUCT_DECLARATOR_LIST_REST_MISSING_REST,
	PARSER_ERROR_STRUCT_DECLARATOR_LIST_REST_MISSING_STRUCT_DECLARATOR,
	PARSER_ERROR_PARAMETER_TYPE_LIST_MISSING_ELLIPSIS,
	PARSER_ERROR_STRUCT_OR_UNION_SPECIFIER_MISSING_STRUCT_DECLARATION_LIST,
	PARSER_ERROR_STRUCT_OR_UNION_SPECIFIER_MISSING_CLOSE_BRACE,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_REST_AFTER_CLOSE_NO_PARAM,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_REST_AFTER_CLOSE_WITH_PARAM,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_CLOSE_PAREN_AFTER_PARAMS,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_REST_AFTER_CLOSE_NO_SIZE,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_REST_AFTER_CLOSE_SIZED,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_CLOSE_BRACKET_AFTER_SIZED,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_REST_MISSING_CLOSE_BRACKET_OR_CONSTANT,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_REST_AFTER_CLOSE_NO_PARAM,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_REST_AFTER_CLOSE_WITH_PARAM,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_CLOSE_PAREN_AFTER_PARAMS,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_REST_AFTER_ABSTRACT_DECLARATOR,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_CLOSE_PAREN_AFTER_ABSTRACT_DECLARATOR,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_REST_AFTER_CLOSE_NO_SIZE,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_REST_AFTER_CLOSE_SIZED,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_CLOSE_BRACKET_AFTER_SIZED,
	PARSER_ERROR_DIRECT_ABSTRACT_DECLARATOR_MISSING_CLOSE_BRACKET_OR_CONSTANT,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_STATEMENT_AFTER_LABEL,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_STATEMENT_AFTER_CASE,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_COLON_AFTER_CASE,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_CONSTANT_AFTER_CASE,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_STATEMENT_AFTER_DEFAULT,
	PARSER_ERROR_LABELED_STATEMENT_MISSING_COLON_AFTER_DEFAULT,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_STATEMENT_AFTER_ELSE,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_STATEMENT_AFTER_IF,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_CLOSE_PAREN_AFTER_IF,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_EXPRESSION_AFTER_IF,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_OPEN_PAREN_AFTER_IF,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_STATEMENT_AFTER_SWITCH,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_CLOSE_PAREN_AFTER_SWITCH,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_EXPRESSION_AFTER_SWITCH,
	PARSER_ERROR_SELECTION_STATEMENT_MISSING_OPEN_PAREN_AFTER_SWITCH,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_STATEMENT_AFTER_WHILE_CLOSE_PAREN,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_CLOSE_PAREN_AFTER_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_EXPRESSION_AFTER_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_OPEN_PAREN_AFTER_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_SEMICOLON_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_CLOSE_PAREN_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_EXPRESSION_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_OPEN_PAREN_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_WHILE_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_STATEMENT_AFTER_DO_WHILE,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_STATEMENT_AFTER_SMALL_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_STATEMENT_AFTER_BIG_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_CLOSE_PAREN_AFTER_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_EXPRESSION_OR_CLOSE_PAREN_AFTER_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_EXPRESSION_STATEMENT_2_AFTER_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_EXPRESSION_STATEMENT_1_AFTER_FOR,
	PARSER_ERROR_ITERATION_STATEMENT_MISSING_OPEN_PAREN_AFTER_FOR,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_SEMICOLON_AFTER_GOTO,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_IDENTIFIER_AFTER_GOTO,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_SEMICOLON_AFTER_CONTINUE,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_SEMICOLON_AFTER_BREAK,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_SEMICOLON_AFTER_RETURN,
	PARSER_ERROR_JUMP_STATEMENT_MISSING_SEMICOLON_AND_EXPRESSION_AFTER_RETURN,
	PARSER_ERROR_CONSTANT_OVERFLOW
};
